package gov.lbl.nest.common.monitor;

import java.util.Map;
import java.util.UUID;

/**
 * This class provide an implementation of the {@link Instrumentation} abstract
 * class that delegates it responsibilities to a {@link InstrumentationManager}
 * implementation.
 *
 * @author patton
 *
 */
public abstract class SimpleInstrumentation extends
                                            Instrumentation {

    // public static final member data

    // protected static final member data

    // static final member data

    // private static final member data

    // private static member data

    // private instance member data

    /**
     * The name that will form the basis for all event types generated by the
     * resulting {@link Instrumentation} instance.
     */
    private final String name;

    // constructors

    /**
     * Creates an instance of this class.
     *
     * @param name
     *            the name that will form the basis for all event types generated by
     *            the resulting {@link Instrumentation} instance.
     */
    protected SimpleInstrumentation(String name) {
        this.name = name;
    }

    // instance member method (alphabetic)

    @Override
    public void end() {
        final String type = name + ".end";
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        null,
                        null);
    }

    @Override
    public void end(Map<String, String> attributes) {
        final String type = name + ".end";
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        null,
                        attributes);
    }

    @Override
    public void end(UUID uuid,
                    Map<String, String> attributes) {
        final String type = name + ".end";
        final String uuidAsString;
        if (null == uuid) {
            uuidAsString = null;
        } else {
            uuidAsString = uuid.toString();
        }
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        uuidAsString,
                        attributes);
    }

    @Override
    public void error(int status) {
        final String type = name + ".error";
        pointOfInterest(type,
                        Level.INFO,
                        status,
                        null,
                        null);
    }

    @Override
    public void error(int status,
                      Map<String, String> attributes) {
        final String type = name + ".error";
        pointOfInterest(type,
                        Level.INFO,
                        status,
                        null,
                        attributes);
    }

    @Override
    public void error(int status,
                      UUID uuid,
                      Map<String, String> attributes) {
        final String type = name + ".error";
        final String uuidAsString;
        if (null == uuid) {
            uuidAsString = null;
        } else {
            uuidAsString = uuid.toString();
        }
        pointOfInterest(type,
                        Level.INFO,
                        status,
                        uuidAsString,
                        attributes);
    }

    /**
     * Called when this item being instrumented begins its responsibilities.
     *
     * @param type
     *            the type of event that occurred at this point of interest.
     * @param level
     *            the level of detail of this point of interest.
     * @param status
     *            The status, if any, of an operation executed this point of
     *            interest.
     * @param guid
     *            the guid associated of event that occurred at this point of
     *            interest.
     * @param attributes
     *            the other attributes to associated with this point of interest.
     */
    protected abstract void pointOfInterest(String type,
                                            Level level,
                                            Integer status,
                                            String guid,
                                            Map<String, String> attributes);

    @Override
    public void pointOfInterst(String label) {
        final String type = name + "."
                            + label;
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        null,
                        null);
    }

    @Override
    public void pointOfInterst(String label,
                               Map<String, String> attributes) {
        final String type = name + "."
                            + label;
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        null,
                        attributes);
    }

    @Override
    public void pointOfInterst(String label,
                               UUID uuid,
                               Map<String, String> attributes) {
        final String type = name + "."
                            + label;
        final String uuidAsString;
        if (null == uuid) {
            uuidAsString = null;
        } else {
            uuidAsString = uuid.toString();
        }
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        uuidAsString,
                        attributes);
    }

    @Override
    public void start() {
        final String type = name + ".start";
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        null,
                        null);
    }

    @Override
    public void start(Map<String, String> attributes) {
        final String type = name + ".start";
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        null,
                        attributes);
    }

    @Override
    public void start(UUID uuid,
                      Map<String, String> attributes) {
        final String type = name + ".start";
        final String uuidAsString;
        if (null == uuid) {
            uuidAsString = null;
        } else {
            uuidAsString = uuid.toString();
        }
        pointOfInterest(type,
                        Level.INFO,
                        null,
                        uuidAsString,
                        attributes);
    }

    // static member methods (alphabetic)

    // Description of this object.
    // @Override
    // public String toString() {}

    // public static void main(String args[]) {}
}
